/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef SCD_TERMINAL_CPP
#define SCD_TERMINAL_CPP

#include <wx/caret.h>
#include <wx/clipbrd.h>
#include <ctype.h>

// ============================================================================

#define TerminalColorTypeCount 8

//terminal rC
wxColour TerminalColors[2][TerminalColorTypeCount] =
{
	{	//`r (¬ŵQ)
		wxColour(  0,  0,  0), wxColour(128,  0,  0), wxColour(  0,128,  0), wxColour(128,128,  0),
		wxColour(  0,  0,128), wxColour(128,  0,128), wxColour(  0,128,128), wxColour(192,192,192)
	} ,
	{	//G
		wxColour(128,128,128), wxColour(255,  0,  0), wxColour(  0,255,  0), wxColour(255,255,  0),
		wxColour(  0,  0,255), wxColour(255,  0,255), wxColour(  0,255,255), wxColour(255,255,255)
	}
};

// ============================================================================

static bool always_highlight = false;	//ǤHqWr|㪺SOt, oӿﶵL̥iHҦrܦG
//ΨӴyzC terminal char ݩ
typedef struct TerminalChar
{
public:
	//bΦr , ΦrĤ@byte , ΦrĤGbyte
	typedef enum { CH_CHAR , CH_WORDFIRST , CH_WORDLAST } CHAR_TYPE;

private:

	struct		//Cݩ
	{
		unsigned char TextColor : 4;	//rC
		unsigned char BackColor : 4;	//IC
	} Color;

	struct 		//Sݩ
	{
		unsigned char isHighlight : 1;	//G
		unsigned char isUnderline : 1;	//u
		unsigned char isBlink : 1;		//{{

		unsigned char chartype : 2;
		unsigned char linktype : 3;
	} property;

public:

	char ch;

	static inline bool getAlwaysHighlight()
	{	return always_highlight;	}
	static inline void setAlwaysHighlight(bool b)
	{	always_highlight = b;	}

	//wӦrO [bΦr] [ΦrĤ@ byte] [ΦrĤG byte]
	inline void setCharType( CHAR_TYPE t )
	{	property.chartype = t;	}
	inline CHAR_TYPE getCharType()
	{	return (CHAR_TYPE)property.chartype;	}

	//ӦrO_@p@
	inline void setLinkType( LINK_TYPE _l )
	{	property.linktype = _l;	}
	inline LINK_TYPE getLinkType()
	{	return (LINK_TYPE)property.linktype;	}

	//rSݩ
	inline void setHighlight(bool to_highlight)
	{	property.isHighlight = to_highlight ? 1 : 0;	}
	inline bool getHighlight()
	{	return (always_highlight || property.isHighlight) ? true : false;	}
	inline void setBlink(bool to_blink)
	{	property.isBlink = to_blink ? 1 : 0;	}
	inline bool getBlink()
	{	return property.isBlink ? true : false;	}
	inline void setUnderline(bool to_Underline)
	{	property.isUnderline = to_Underline ? 1 : 0;	}
	inline bool getUnderline()
	{
/*
#if defined(__WXGTK__)	//GTK ثe䴩ur, ҥHu\
		return false;
#else
*/
		return property.isUnderline ? true : false;
//#endif
	}

	//rCݩ
	inline void setTextColor(int ColorCode)
	{
		if( ColorCode >= 30 && ColorCode <= 37 )
			Color.TextColor = ColorCode - 30;
	}
	inline wxColour getTextColor(bool _selected = false)
	{
		if( ! _selected )
			return TerminalColors[ getHighlight() ][ Color.TextColor ];
		else
		{
			wxColour c( TerminalColors[ getHighlight() ][ Color.TextColor ] );
			c.Set( ~c.Red(), ~c.Green(), ~c.Blue() );
			return c;
		}
   	}
	inline int getTextColorCode()
	{	return Color.TextColor + 30;	}

   	//rIݩ
	inline void setBgColor(int ColorCode)
	{
		if( ColorCode >= 40 && ColorCode <= 47 )
			Color.BackColor = ColorCode - 40;
	}
	inline wxColour getBgColor(bool _selected = false)
	{
		if( ! _selected )
			return TerminalColors[0][ Color.BackColor ];
		else
		{
			wxColour c( TerminalColors[0][ Color.BackColor ] );
			c.Set( ~c.Red(), ~c.Green(), ~c.Blue() );
			return c;
		}
   	}
	inline int getBgColorCode()
	{	return Color.BackColor + 40;	}

	wxString getDiffANSICode(TerminalChar & _c)
	{
		wxString code;
		code = _T("\x1b[");

		if(  ( _c.getHighlight() && ! getHighlight() ) 	//pGݭnGשΰ{{Ωuݩʪ
  			|| ( _c.getBlink() && ! getBlink() )
  			|| ( _c.getUnderline() && ! getUnderline() ) )
		{
			TerminalChar def_ch = getDefaultCharProperty();
			code += _T(";");
			if( getHighlight() )	code += _T("1;");
			if( getUnderline() )	code += _T("4;");
			if( getBlink() )	code += _T("5;");
			if( getTextColorCode() != def_ch.getTextColorCode() )	code += wxString::Format( _T("%d;"), getTextColorCode() );
			if( getBgColorCode()   != def_ch.getBgColorCode() )		code += wxString::Format( _T("%d"), getBgColorCode() );
		}
		else
		{
			if( ! _c.getHighlight() && getHighlight() )	code += _T("1;");
			if( ! _c.getUnderline() && getUnderline() )	code += _T("4;");
			if( ! _c.getBlink() && getBlink() )	code += _T("5;");
			if( _c.getTextColorCode() != getTextColorCode() )	code += wxString::Format( _T("%d;"), getTextColorCode() );
			if( _c.getBgColorCode() != getBgColorCode() )		code += wxString::Format( _T("%d"), getBgColorCode() );
		}
		if( code.Last() == ';' )	code.RemoveLast();
		code += _T("m");
		return code;
	}

	wxString getANSICode()
	{
		wxString code;
		TerminalChar def_ch = getDefaultCharProperty();
		code = _T("\x1b[");
		code += _T("0");	//Gשΰ{{Ωuݩʪ
		if( getHighlight() )	code += _T(";1");
		if( getUnderline() )	code += _T(";4");
		if( getBlink() )	code += _T(";5");
		if( getTextColorCode() != def_ch.getTextColorCode() )	code += wxString::Format( _T(";%d"), getTextColorCode() );
		if( getBgColorCode()   != def_ch.getBgColorCode() )		code += wxString::Format( _T(";%d"), getBgColorCode() );
		code += _T("m");
		return code;
	}
	
	bool withSameProperty(TerminalChar & ch)
	{
		if( getHighlight() != ch.getHighlight() )	return false;
		if( getBlink() != ch.getBlink() )	return false;
		if( getUnderline() != ch.getUnderline() )	return false;
		if( getTextColor() != ch.getTextColor() )	return false;
		if( getBgColorCode() != ch.getBgColorCode() )	return false;
		return true;
	}

	inline void setColorCode(int ColorCode)
 	{
		if( ColorCode >= 30 && ColorCode <= 37 )
			setTextColor(ColorCode);
		else if( ColorCode >= 40 && ColorCode <= 47 )
			setBgColor(ColorCode);
 		else if( ColorCode == 0 )
		{
			setTextColor(37);
			setBgColor(40);
			setHighlight(false);
			setBlink(false);
			setUnderline(false);
		}
 		else if( ColorCode == 1 )
 			setHighlight(true);
 		else if( ColorCode == 4 )
 			setUnderline(true);
 		else if( ColorCode == 5 )
 			setBlink(true);
 		else if( ColorCode == 7 )
 		{
 			setTextColor(30);
 			setBgColor(47);
		}
  	}
	inline static TerminalChar getDefaultCharProperty()
	{
		TerminalChar tc;
		tc.setTextColor(37);
		tc.setBgColor(40);
		tc.setHighlight(false);
		tc.setBlink(false);
		tc.setUnderline(false);
		tc.ch = '\0';
		tc.setCharType(CH_CHAR);
		tc.setLinkType(LINK_NONE);
		return tc;
	}

};

// ============================================================================

// *************** SCD_Terminal O ***************
//
//1. ΨӴyz terminal  (rꤺe, CӦrݩ, etc...)
//2. tdø
//      repaint() ø
//      repaint(int x, int y, int w, int h) ø
//3. parse() , Ҧpq wxSocketBase::Read() o
//
// ********************************************************

static int line_wraped_length = 80;
class SCD_Terminal
{


//---------------------------------------------------------------
//pG SCD_Terminal N|b wxScrolledWindow WøϪ,
//@wn]w setScrolledWindow() oӨ禡
//oӨ禡| SCD_Terminal bø(repaint())Hβʴ(updateCaret())ɭ,
//̷ wxScrolledWindow bmX۹
//o SCD_Terminal ~b wxScrolledWindow `
private:
    wxScrolledWindow *scrollwin;
public:
    inline void setScrolledWindow(wxScrolledWindow *win)
    {	scrollwin = win;	}
	inline int getLineCountInView();	//oثeܰϰ@@ܴXT
	void ScrollToCaret();	//ⱲbʨЩҦbB
//---------------------------------------------------------------


private:
	wxPoint server_stored_cur_pos;

public:
	SCD_Terminal(wxWindow *win);
	~SCD_Terminal();

	void setColumnRow(int _c, int _r);	//]w, C

	//г]w
	inline void getXY(int *_x, int *_y);	//oЦm
	inline void gotoXY(int _x, int _y);//Nв (_x,_y)
	inline void goUp(int _v);			//ЩW
	inline void goDown(int _v);		//ЩU
	inline void goLeft(int _v);		//Щ
	inline void goRight(int _v);		//Щk
	inline void goLineHead();			//вP@檺}Y
	inline void updateCaret();			//sЦm


	//ʵ
	inline void ScrollUp(int _v);		//W
	inline void ScrollDown(int _v);	//U

	//M
 	inline void cleanScreen();			//Mù
	inline void CleanLineTail();		//M
	inline void CleanLine(int _y);			//M

	//J
	int parse(char *str , int len);		//Xr (䤤iHX)

	wxSize getWindowSize()	{	return wxSize( col_count*char_width, row_count*char_height );	}
	wxSize getCharSize()	{	return wxSize( char_width, char_height );	}

	//{{r method
private:
	bool hasBlinkChar;
protected:
	inline void setHasBlinkChar(bool _v)	{	hasBlinkChar = _v;	}
public:	
	inline bool getHasBlinkChar()	{	return hasBlinkChar;	}
	void setBlinkCharVisibility(bool _v);	//O_ܰ{{r
	inline bool getBlinkCharVisibility()	{	return blBlinkCharVisibility;	}

	//sø
	void OnPaint(wxPaintEvent& event);
	void OnPaint(wxDC *dc);
	inline void repaint(bool eraseBackground = false);
	void repaint(wxDC *dc, int x, int y, int w, int h);

protected:
	//ø
	void repaintChar(int _x, int _y);	//ܦm (_x,_y) r
	void repaintLine(int _y);

	//Nƹyഫ۹ry
	void MouseXY_to_TextXY(int m_x, int m_y, int & t_x, int & t_y);

protected:
	TerminalChar  **term_data;	//terminal CӦr, ݩ
	void updateScrollBar(int linecount)
 	{
      	row_count = linecount;
      	if( scrollwin )	scrollwin->SetVirtualSize( getWindowSize() );
	}
private:
	TerminalChar  now_char_property;	//ثerݩ

	int col_count, row_count;	//terminal C
	int cur_x, cur_y;			//ЩҦbm
public:
	int getLineLength(int _line);
	inline void getColumnRowCount(int *_col, int *_row)
 	{
		if(_col)	*_col = col_count;
		if(_row)	*_row = row_count;
  	}

private:

	int screen_width, screen_height;	//ee
	int char_width, char_height;	//reװ

	bool blBlinkCharVisibility;	//O_ܰ{{r

	bool is_X_in_bound(int _x);
	bool is_Y_in_bound(int _y);

	wxWindow *parentWindow;
	wxDC *currentDC;
	bool blEnableDrawing;

protected:
	void adjustLineCharInfo(int _y);	//sYҦr type ݩ (P_bΦrMΦr)
	inline bool isWord(char first, char last);

public:
	//קKtΦ]shܧƤeӳye{{
	void BeginDrawing(wxDC *dc);
	void EndDrawing();
	void EnableDrawing(bool b)	{	blEnableDrawing = b;	}
private:
	inline bool isDrawing()	{	return (currentDC != NULL);	}
	inline wxDC* getDC()	//oثe DC
 	{
      	if( ! blEnableDrawing || ! getVisible() )	return NULL;
  		return currentDC;
    }
	
	wxCaret* getCaret()
 	{	return ( parentWindow == NULL ) ? NULL : parentWindow->GetCaret();	}

protected:
	inline bool isCurrentAWord();	//ХثeҳBmO_ΦrĤ@ byte
	inline bool isLeftAWord();		//ХثeҳBmO_Φr

private: bool isVisible;
public:
	void Show();
	inline void Hide()	{	isVisible = false;	getCaret()->Hide();		}
	inline bool getVisible()	{	return isVisible;	}

	inline wxWindow* getParentWindow()	{	return parentWindow;	}
	
	wxFont term_fnt;
	void SetFont(const wxFont& fnt);
	wxFont& GetFont()	{	return term_fnt;	}

private:
	typedef void (*ON_LINK_CLICKED_FUNC)(char *, LINK_TYPE);
	ON_LINK_CLICKED_FUNC OnLinkClickedFunc;
public:
	void SetOnLinkClickedFunc( ON_LINK_CLICKED_FUNC _f )	{	OnLinkClickedFunc = _f;	}

	//***** ƹƥ, ΨӺ޲z [r] ʧ@ *****//

protected:
	int start_x, start_y, end_x, end_y;	//rd򪺶}YM
	unsigned char selectState;	//0:| 1:U 2:br 3: (OdХ)
	inline bool isCharSelected(int _x, int _y);
	inline void getSelectionInfo(int *sx, int *sy, int *ex, int *ey)
	{
     	if( start_y < end_y
			|| ( start_y == end_y  &&  start_x <= end_x )  )
		{	*sx = start_x;	*sy = start_y;	*ex = end_x;	*ey = end_y;	}
		else
		{	*ex = start_x;	*ey = start_y;	*sx = end_x;	*sy = end_y;	}
	}

public:
	void OpenSelectionAsHyperlink()
	{
		if( selectState != 3 )	return;
		int sx, sy, ex, ey;
		getSelectionInfo( &sx, &sy, &ex, &ey );
		int s = sy * col_count + sx;
		int e = ey * col_count + ex;
		char *link = new char[e-s+1];
		int i = 0;
		for(int y=sy;y<=ey;y++)
		{
			int line_len = getLineLength(y);
			bool b = false;
			for(int x=0;x<line_len;x++)
			{
				if( y==sy && x<sx )	continue;
				if( y==ey && x>ex )	continue;
				char ch = term_data[y][x].ch;
				if(!b)
				{
					if(ch == ' ')	continue;	//C@}YҦťզr
					else b = true;
				}
				link[i++] = ch;
			}
		}
		link[i] = '\0';
		OpenHyperlink(link);
		delete link;
	}
	
	//ask if someone call you (find is any rung bell)
private:
	bool bBell;
public:
	bool isBell()
 	{
  		if( bBell )
  		{
  			bBell = false;
  			return true;
  		}
  		else return false;
	}


private:
    bool blEnableDoubleByteDetection;	//O_}줸\ 
public:
	inline void setEnableDoubleByteDetection(bool b)
    {
    	if( blEnableDoubleByteDetection == b )	return;
    	blEnableDoubleByteDetection = b;
    }
	inline bool getEnableDoubleByteDetection()
	{	return blEnableDoubleByteDetection;	}

protected:
	wxString GetLineWrapedString(char *txt);	//N txt ۰_, ϨC@檺rƤ|WLw
public:
	static void SetLineWrapedLength(int len)	//]w۰_檺
	{
		if( len < 3 || len > 80 )	return;
		line_wraped_length = len;
	}
	static int GetLineWrapedLength()
	{	return line_wraped_length;	}

public:

	//r, ƻsr 
	void SelectAll();
	void CancelSelection();	//
	wxString GetSelectionContent(bool withANSI);	//oҿr
	wxString GetAllContent(bool withANSI);			//oҦr 
	void CopySelectionToClipboard(bool withANSI);	//NrƻsŶKï
	inline bool isSelected()	{	return (selectState == 2 || selectState == 3);	}

	//ƹƥ (Bzrʧ@)
	void OnMouseLeftDown(wxMouseEvent& event);
	void OnMouseMotion(wxMouseEvent& event);
	void OnMouseLeftUp(wxMouseEvent& event);
};

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
SCD_Terminal::SCD_Terminal(wxWindow *win)
{
	term_data = NULL;
	currentDC = NULL;
	scrollwin = NULL;
	parentWindow = win;
	isVisible = false;
	blEnableDrawing = true;

	SetFont( parentWindow->GetFont() );
	char_height = parentWindow->GetFont().GetPointSize();
	char_width  = char_height / 2;

	term_data = NULL;
	setColumnRow(80,24);

	gotoXY(0,0);
	blBlinkCharVisibility = true;
	setHasBlinkChar(false);
	OnLinkClickedFunc = NULL;

	selectState = 0;	//ϥΪ̩|}lr
	blEnableDoubleByteDetection = true;

	now_char_property = now_char_property.getDefaultCharProperty();
	bBell = false;
}
// ----------------------------------------------------------------------------
SCD_Terminal::~SCD_Terminal()
{
	for(int y=0;y<row_count;y++)	delete term_data[y];
	delete term_data;
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_Terminal::SetFont(const wxFont& fnt)
{
	//]wr, rjp, 
	term_fnt = fnt;

	wxClientDC dc(parentWindow);
	dc.SetFont(fnt);
	char_width  = dc.GetCharWidth();
	char_height = dc.GetCharHeight();

	wxCaret *caret = parentWindow->GetCaret();
	if(caret)	caret->SetSize( char_width, 2 );

	if( scrollwin )
	{
		int _x, _y;
		scrollwin->GetViewStart( &_x, &_y );
		scrollwin->SetScrollbars( char_width, char_height, 80, row_count, _x, _y );
	}
}
// ----------------------------------------------------------------------------
void SCD_Terminal::Show()
{
	if( getVisible() )	return;
	if( parentWindow == NULL )	return;
	
	isVisible = true;

	repaint();	//ø

	//ܴ
	wxCaret *caret = parentWindow->GetCaret();
	if( caret == NULL )
	{
		wxMessageBox(_T("caret not found"));
		parentWindow = NULL;
	}
	else
	{
		caret->SetSize( char_width, 2 );
		caret->Show();
	}
}
// ----------------------------------------------------------------------------
void SCD_Terminal::setColumnRow(int _c, int _r)
{
	if( term_data == NULL )
	{	col_count = 0;	row_count = 0;	}

	if( _c == col_count && _r == row_count )	return;

	TerminalChar **old_term_data = term_data;

	term_data = new (TerminalChar*)[_r];
	for(int i=0;i<_r;i++)
		term_data[i] = new TerminalChar[_c];

	TerminalChar dch = TerminalChar::getDefaultCharProperty();
	int _k = (_c > col_count) ? col_count : _c;
	for(int y=0;y<_r;y++)
	{
		int x = 0;
		if( y < row_count && old_term_data )
		{	for(x=0;x<_k;x++)	term_data[y][x] = old_term_data[y][x];	}
		for(;x<_c;x++)	term_data[y][x] = dch;
	}

	//MªO
	if( old_term_data )
	{
     	for(int y=0;y<row_count;y++)	delete old_term_data[y];
     	delete old_term_data;
	}

	col_count = _c;
	row_count = _r;
	if( cur_x >= _c )	cur_x = _c - 1;
	if( cur_y >= _r )	cur_y = _r - 1;
}
// ----------------------------------------------------------------------------
void SCD_Terminal::BeginDrawing(wxDC *dc)	//קKtΦ]shܧƤeӳye{{
{
	if( ! getVisible() )	return;
	currentDC = dc;
	if(currentDC == NULL)	return;
	if(scrollwin)	scrollwin->PrepareDC(*currentDC);

	if(parentWindow != NULL)
	{
		parentWindow->GetCaret()->Move(-100, -100);
		currentDC->SetFont( GetFont() );
	}

   	currentDC->BeginDrawing();
	currentDC->SetPen(*wxTRANSPARENT_PEN);	//T DrawRectangle() ɥ Pen e
}
// ----------------------------------------------------------------------------
void SCD_Terminal::EndDrawing()
{
	if( ! getVisible() )	return;
	if( currentDC != NULL ) currentDC->EndDrawing();
	currentDC = NULL;
	updateCaret();
}
// ----------------------------------------------------------------------------
inline int SCD_Terminal::getLineCountInView()	//oثeܰϰ@@ܴXT
{
	wxSize ws = getParentWindow()->GetClientSize();
	wxSize cs = getCharSize();
	return ws.GetHeight() / cs.GetHeight();
}
// ----------------------------------------------------------------------------
void SCD_Terminal::ScrollToCaret()
{
    if( scrollwin == NULL )	return;
    
	int lc = getLineCountInView();

	//pGЩҳBmWXbܽd, hʱb
	int _vx, _vy;
	scrollwin->GetViewStart(&_vx, &_vy);	//in scroll units
   	if( cur_y < _vy )	scrollwin->Scroll( -1, cur_y );
   	else if( cur_y >= _vy + (lc-1) )	scrollwin->Scroll( -1, cur_y - (lc-1) );
	//repaint();	//ݭn repaint() ]b wxScrolledWindow::Scroll() ɭ, wxScrolledWindow N|۰ Refresh ݭnø
}
// ----------------------------------------------------------------------------
void SCD_Terminal::updateCaret()
{
	if( isDrawing() )	return;
	if( ! getVisible() )	return;

	wxCaret *c;
	c = getCaret();
	
	if( c != NULL )
	{
     	int _x , _y;
     	_x = cur_x * char_width;
     	_y = cur_y * char_height + char_height - 2;
     	if( scrollwin )	scrollwin->CalcScrolledPosition(_x,_y,&_x,&_y);
		c->Move( _x , _y );
	}
}
// ----------------------------------------------------------------------------
bool SCD_Terminal::is_X_in_bound(int _x)
{	return ( _x >= 0 ) && ( _x < col_count );	}
// ----------------------------------------------------------------------------
bool SCD_Terminal::is_Y_in_bound(int _y)
{	return ( _y >= 0 ) && ( _y < row_count );	}
// ----------------------------------------------------------------------------
void SCD_Terminal::getXY(int *_x, int *_y)
{
	if(_x)	*_x = cur_x;
 	if(_y)	*_y = cur_y;
}
// ----------------------------------------------------------------------------
void SCD_Terminal::gotoXY(int _x, int _y)
{
	if( is_X_in_bound(_x) )	cur_x = _x;
	if( is_Y_in_bound(_y) )	cur_y = _y;

	updateCaret();
}
// ----------------------------------------------------------------------------
void SCD_Terminal::goUp(int _v = 1)
{	gotoXY( cur_x , cur_y - _v );	ScrollToCaret();	}
// ----------------------------------------------------------------------------
void SCD_Terminal::goDown(int _v = 1)
{	gotoXY( cur_x , cur_y + _v );	ScrollToCaret();	}
// ----------------------------------------------------------------------------
void SCD_Terminal::goLeft(int _v = 1)
{	gotoXY( cur_x - _v , cur_y );	ScrollToCaret();	}
// ----------------------------------------------------------------------------
void SCD_Terminal::goRight(int _v = 1)
{	gotoXY( cur_x + _v , cur_y );	ScrollToCaret();	}
// ----------------------------------------------------------------------------
void SCD_Terminal::goLineHead()
{	gotoXY( 0 , cur_y );	}
// ----------------------------------------------------------------------------
void SCD_Terminal::cleanScreen()
{
	selectState = 0;

	TerminalChar defaultCharProperty = now_char_property.getDefaultCharProperty();
	for(int y=0;y<row_count;y++)
		for(int x=0;x<col_count;x++)
			term_data[y][x] = defaultCharProperty;

	setHasBlinkChar(false);

	wxDC *dc = getDC();
	if(dc != NULL)
 	{
	    dc->SetBrush( wxBrush( TerminalChar::getDefaultCharProperty().getBgColor() , wxSOLID ) );
  		dc->DrawRectangle(0,0, char_width * col_count , char_height * row_count);
	}

	gotoXY(0,0);
}
// ----------------------------------------------------------------------------
void SCD_Terminal::CleanLine(int _y)
{
	TerminalChar defaultCharProperty = now_char_property.getDefaultCharProperty();

	for(int x=0;x<col_count;x++)
		term_data[_y][x] = defaultCharProperty;

	wxDC *dc = getDC();
	if(dc != NULL)
 	{
	    dc->SetBrush( wxBrush( TerminalChar::getDefaultCharProperty().getBgColor() , wxSOLID ) );
  		dc->DrawRectangle(0, char_height * _y, char_width * col_count , char_height );
	}
}
// ----------------------------------------------------------------------------
void SCD_Terminal::CleanLineTail()
{
	TerminalChar defaultCharProperty = now_char_property.getDefaultCharProperty();

	for(int x=cur_x;x<col_count;x++)
		term_data[cur_y][x] = defaultCharProperty;
}
// ----------------------------------------------------------------------------
void SCD_Terminal::ScrollUp(int _v)
{
	TerminalChar *tmp_lines[100];

	for(int i=0;i<_v;i++)	tmp_lines[i] = term_data[row_count-_v+i];	//Ȧs᭱ _v 
	for(int y=row_count-1;y>=_v;y--)	//ѤUӤW, h
	{
		term_data[y] = term_data[y-_v];
//		repaintLine(y);	//need optimization
	}

	wxDC *dc = getDC();
	if(dc != NULL)
	{
		int _w, _h;
		_w = col_count * char_width;
		_h = ( row_count - _v ) * char_height;
		dc->Blit( 0, _v * char_height , _w , _h , dc, 0, 0 );
	}

	for(int i=0;i<_v;i++)
	{
		term_data[i] = tmp_lines[i];
		CleanLine(i);
	}
}
// ----------------------------------------------------------------------------
void SCD_Terminal::ScrollDown(int _v)
{
	TerminalChar *tmp_lines[100];
	int y;

	for(y=0;y<_v;y++)	tmp_lines[y] = term_data[y];	//Ȧse _v 
	for(y=0;y<row_count-_v;y++)	//ѤWӤU, h
	{
		term_data[y] = term_data[y+_v];
//		repaintLine(y);	//need optimization
	}
	
	wxDC *dc = getDC();
	if(dc != NULL)
	{
		int _w, _h;
		_w = col_count * char_width;
		_h = ( row_count - _v ) * char_height;
		dc->Blit( 0, 0, _w , _h , dc, 0, _v * char_height );
	}

	for(int i=0;i<_v;i++)
	{
		term_data[y+i] = tmp_lines[i];
		CleanLine(y+i);
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
int SCD_Terminal::getLineLength(int _line = -1)
{
	if( _line == -1 )	_line = cur_y;

	int i;
	for(i=col_count-1;i>=0 && term_data[_line][i].ch == '\0' ;i--);
	return i+1;
}

bool SCD_Terminal::isWord(char first, char last)
{
//	if(  (first>='\xa0' && first<='\xfe') &&
	if(  (first>='\xa0' && first<='\xf9') &&
 		( (last>='\x40' && last<='\x7e') || (last>'\xa0' && last<='\xfe') )  );
	else return false;

/*
#if defined(__WXGTK__)	//GTK UY Big5 OdϷ|y crash ҥHnưoǱ

if( (unsigned char)first == 0x81 && (unsigned char)last >= 0x40 )	return false;	//ϥΪ̳yr
if( (unsigned char)first >= 0x82 && (unsigned char)first <= 0xa0 )	return false;	//ϥΪ̳yr
if( (unsigned char)first == 0xa3 && (unsigned char)last >= 0xc0 )	return false;	//Ÿ
if( (unsigned char)first == 0xc7 && (unsigned char)last >= 0xf3 )	return false;	//Od
if( (unsigned char)first == 0xc8 )	return false;	//Od
if( (unsigned char)first == 0xfa && (unsigned char)last >= 0x40 )	return false;	//ϥΪ̳yrΤηs`Φr
if( (unsigned char)first >= 0xfb )	return false;	//ϥΪ̳yrΤηs`Φr

#endif
*/
	return true;

}
// ----------------------------------------------------------------------------
bool SCD_Terminal::isCurrentAWord()	//ХثeҳBmO_ΦrĤ@ byte
{	return term_data[cur_y][cur_x].getCharType() == TerminalChar::CH_WORDFIRST;	}
// ----------------------------------------------------------------------------
bool SCD_Terminal::isLeftAWord()		//ХثeҳBmO_Φr
{
	if( ! is_X_in_bound( cur_x - 1 ) )	return false;
	return term_data[cur_y][cur_x-1].getCharType() == TerminalChar::CH_WORDLAST;
}
// ----------------------------------------------------------------------------
int SCD_Terminal::parse(char *input , int len = -1)
{
	wxDC *dc = NULL;
	if( getVisible() )
	{
		dc = new wxClientDC( getParentWindow() );
		BeginDrawing(dc);
	}

	if( len < 0 )
		len = strlen(input);

	int unread_data_len = 0;	//pG̫J챱XƤ㪺p, hR̫᪺X
								//öǦ^̫SRXƪ

	char *end = input + len;


	//OsT, Kø
	int last_line_index = cur_y;
 	bool line_updated = false;


	while( input != end )	//pG٦
	{
		if( input > end )
  		{

/* ɵ{|Jo if ϶ , OzפWӦ|iJo

    		wxMessageBox(_T("parse() out of bound"));

wxString str = _T("");
for(char *r=input-10;r<end;r++)	str += wxString::Format("%c", *r);
wxMessageBox(str);

*/

    		break;
		}


		if( *input == '\0' )	// r'\0'
		{
			input ++;
			continue;
		}

		if( *input == '\x1b' )	//X}Y
  		{

  			if( input + 1 == end )	//pG [X}Y] , hX
  			{
  				unread_data_len = 1;
  				break;
			}
			else if( input[1] == 'M' )	//(ptt.twbbs.org |ΨoӱXnD ScrollUp(1)
			{
				ScrollUp(1);
				input ++;
				input ++;
				continue;
			}
			else if( input[1] == '[' );	//pGX}YƧ, h~R
   			else	//pGOX, h~ŪU@Ӧr
      		{
      			input ++;
        		continue;
			}

			//ˬdXO_, קK]t buffer ӳyX_
   			//ӳyR~
   			{
	   			int i = 2;
    	  		while(1)
        		{
        			if( & input[i] == end )	//pGXƤ, hX
           			{
						unread_data_len = end - input;
           				i = -1;
						break;
              		}
					else if( isalpha( input[i] ) )	//pGJ챱X, NXO㪺
						break;
					i++;
         		}

         		if( i < 0 )	break;	//pGXhX
     		}


  			input ++;
  			input ++;

			int num_index , num_list[6];	//ΨӰOXܼ
			num_index = 0;
			num_list[0] = -1;
			num_list[1] = -1;

  			while( input != end )	//}lRX
  			{

				if( isdigit( *input ) )
				{
					if( num_list[ num_index ] < 0 )
         				num_list[ num_index ] = 0;

					num_list[ num_index ] = num_list[ num_index ] * 10 + ( *input - '0' );
				}
				else if( *input == ';' )
				{
					if( num_list[ num_index ] < 0 )
						num_list[num_index] = 0;

					if(num_index < 5)	num_index ++;
					num_list[ num_index + 1 ] = -1;
				}
  				else if( isalpha( *input ) )		//X
				{
     				switch( *input )
     				{
     					case 'm' :	//CX
							if(num_list[0] < 0)
								now_char_property = TerminalChar::getDefaultCharProperty();
							else
							{
	     						for(int i=0;num_list[i] >= 0;i++)
	     						{
									if( num_list[i] == 5 )	setHasBlinkChar(true);
	    	 						now_char_property.setColorCode( num_list[i] );
 	 							}
							}
     						break;
     					case 'H' :	//gotoXY
     					case 'f' :	//gotoXY
							if( num_list[0] < 0 || num_list[1] < 0 )
								gotoXY(0,0);
							else
								gotoXY( num_list[1] - 1 , num_list[0] - 1 );
     						break;
     					case 'J' :	//Mù
     						cleanScreen();
     						line_updated = false;
     						break;
     					case 'K' :	//M
							CleanLineTail();
							line_updated = true;
     						break;
     					case 'L' :	//W
							if( num_list[0] > 0 )
       							ScrollUp( num_list[0] );
     						break;
/*
     					case 'A' :	//ФW
     						if(num_list[0] >= 0)	goUp( num_list[0] );
     						else	goUp(1);
       						break;
     					case 'B' :	//ФU
     						if(num_list[0] >= 0)	goDown( num_list[0] );
     						else	goDown(1);
       						break;
     					case 'C' :	//Хk
     						if(num_list[0] >= 0)	goRight( num_list[0] );
     						else	goRight(1);
       						break;
     					case 'D' :	//Х
     						if(num_list[0] >= 0)	goLeft( num_list[0] );
     						else	goLeft(1);
       						break;
*/
						default :	//X
							break;
     				}
     				break;
				}
				else
				{
					//X
				}

				input ++;
  			}
    	}
    	else if( *input == '\n' )	// \x0a
		{
			int c = 1;

			//ѩ``s򴫦ŸX{,
   			//pGs򴫦Ÿ, h@Ū, iHbݭn ScrollDown() ɭ,
      		//sƥHέsøϪt
      		// '\n' M '\r' ``X{
			while( input != end )
			{
    			if( input[1] == '\n' )
       			{	c++;	input++;	}
    			else if( input[1] == '\r' )	input++;
               	else	break;
			}
       		goLineHead();

			//ѩ goDown() i| ScrollDown()
			//C@檺ޱN|ܰ
			//]ns
			if( line_updated )	//pGeƧsL, Nøe@檺
			{
				adjustLineCharInfo( last_line_index );
				repaintLine( last_line_index );
				line_updated = false;
			}

			int tmp_c = row_count - cur_y - 1;
			int caret_down = (c<=tmp_c) ? c : tmp_c;
			if(caret_down > 0)	goDown(caret_down);
			if( c > caret_down )	ScrollDown( c - caret_down );


			last_line_index = cur_y;
     	}
    	else if( *input == '\r' )	// \x0d
		{	goLineHead();	}
    	else if( *input == '\b' )
    	{	goLeft(1);	}
    	else if( *input == '\a' )
    	{	bBell = true;	}
    	else if( *input == '\xff' )
    	{	;	}
    	else
    	{
			term_data[cur_y][cur_x] = now_char_property;
			term_data[cur_y][cur_x].ch = *input;

			goRight(1);
			line_updated = true;
    	}


		if( last_line_index != cur_y )	//pG檺ʧ@
		{
			if( line_updated )	//pGeƧsL, Nøe@檺
			{
				adjustLineCharInfo( last_line_index );
				repaintLine( last_line_index );
				line_updated = false;
			}
			last_line_index = cur_y;
		}

		//~RU@Ӧr
        input ++;
	}

	if( line_updated )	//pGeƧsL, Nøe@檺
	{
		adjustLineCharInfo( last_line_index );
		repaintLine( last_line_index );
	}

	if( getVisible() )
 	{
  		EndDrawing();
		delete dc;
	}

	return unread_data_len;
}
// ----------------------------------------------------------------------------
void SCD_Terminal::adjustLineCharInfo(int _y = -1)
{
	int x = 0;
	if(_y == -1)	_y = cur_y;
	for(x=0;x<col_count-1;x++)
	{
		if( isWord( term_data[_y][x].ch , term_data[_y][x+1].ch ) )
		{

#if defined(__BSD__)

static char table[] = "zs{uqt|r}zs{uqt|r}zs{uqt|r}xw~h";

bool flag = true;
char first = term_data[_y][x].ch;
char last = term_data[_y][x+1].ch;
if( (unsigned char)first == 0xa1 && ! (((unsigned char)last >= 0x40 && (unsigned char)last <= 0x5c) || (unsigned char)last >= 0xad ) )	flag = false;	//bsd
else if( (unsigned char)first == 0xa1 && ( (unsigned char)last == 0x5a || (unsigned char)last == 0xc3 || (unsigned char)last == 0xc5 || (unsigned char)last == 0xfe ) )    flag = false;	//bsd
else if( (unsigned char)first == 0xa2 && (unsigned char)last >= 0x40 && (unsigned char)last <= 0x60 )	flag = false;	//bsd
else if( (unsigned char)first == 0xa2 && (unsigned char)last >= 0xcc )	flag = false;	//bsd
else if( (unsigned char)first == 0xf9 )	flag = false;	//bsd GSkܤjŸ
else if( (unsigned char)first == 0xa3 && (unsigned char)last >= 0xc0 )	flag = false;	//Ÿ
else if( (unsigned char)first == 0xc8 )	flag = false;	//Od


			if( ! flag )	//bsd GSkܤjŸ
			{
				if( (unsigned char)first == 0xf9 && (unsigned char)last >= 0xdd && (unsigned char)last <= 0xfe )
				{
					term_data[_y][x].ch = table[ ( (unsigned char)last - 0xdd ) * 2 ];
					term_data[_y][x+1].ch = table[ ( (unsigned char)last - 0xdd ) * 2 + 1 ];
					term_data[_y][x].setCharType( TerminalChar::CH_WORDFIRST );
					term_data[_y][x+1].setCharType( TerminalChar::CH_WORDLAST );
				}
				else
				{
				term_data[_y][x].setCharType( TerminalChar::CH_CHAR );
				term_data[_y][x].setCharType( TerminalChar::CH_CHAR );
				}
			}
			else
#endif
			{
				term_data[_y][x].setCharType( TerminalChar::CH_WORDFIRST );
				term_data[_y][x+1].setCharType( TerminalChar::CH_WORDLAST );
			}
			x++;
		}
		else
			term_data[_y][x].setCharType( TerminalChar::CH_CHAR );
	}
	if(x==col_count-1)
		term_data[_y][x].setCharType( TerminalChar::CH_CHAR );
		
		
	//Mĳs
	
	int link_start_x;

	for(x=0;x<col_count-3;x++)
	{
		link_start_x = -1;
		if( term_data[_y][x].ch == ':' && term_data[_y][x+1].ch == '/' && term_data[_y][x+2].ch == '/' )
		{
			if( x >= 6 )
			{
				if( term_data[_y][x-6].ch == 't' && term_data[_y][x-5].ch == 'e' &&
					term_data[_y][x-4].ch == 'l' && term_data[_y][x-3].ch == 'n' &&
					term_data[_y][x-2].ch == 'e' && term_data[_y][x-1].ch == 't' )
				{	link_start_x = x - 6;	term_data[_y][x-6].setLinkType( LINK_TELNET );	}
			}
			if( x >= 4 )
			{
				if( term_data[_y][x-4].ch == 'h' && term_data[_y][x-3].ch == 't' &&
					term_data[_y][x-2].ch == 't' && term_data[_y][x-1].ch == 'p' )
				{	link_start_x = x - 4;	term_data[_y][x-4].setLinkType( LINK_HTTP );	}
				else if( term_data[_y][x-4].ch == 's' && term_data[_y][x-3].ch == 'f' &&
					term_data[_y][x-2].ch == 't' && term_data[_y][x-1].ch == 'p' )
				{	link_start_x = x - 4;	term_data[_y][x-4].setLinkType( LINK_SFTP );	}
			}
			if( x >= 3 )
			{
				if( term_data[_y][x-3].ch == 'f' && term_data[_y][x-2].ch == 't' &&
					term_data[_y][x-1].ch == 'p' )
				{	link_start_x = x - 3;	term_data[_y][x-3].setLinkType( LINK_FTP );	}
				else if( term_data[_y][x-3].ch == 'b' && term_data[_y][x-2].ch == 'b' &&
					term_data[_y][x-1].ch == 's' )
				{	link_start_x = x - 3;	term_data[_y][x-3].setLinkType( LINK_TELNET );	}
			}

		}
		else if(term_data[_y][x].ch == '@' && term_data[_y][x].getCharType() == TerminalChar::CH_CHAR )
		{
			int i;
			for(i=x; i>=0 && term_data[_y][i].ch != ' ' && term_data[_y][i].getCharType() == TerminalChar::CH_CHAR ;i--);
			link_start_x = i + 1;
			term_data[_y][link_start_x].setLinkType( LINK_EMAIL );
		}

		if( link_start_x >= 0 )
		{
			int tmp_x = x , link_end_x;
			bool has_dot_char = false;	//WsrꤤO_r '.'
			for(x=link_start_x;x<col_count;x++)
			{
				if( term_data[_y][x].ch == ' ' || term_data[_y][x].ch == '\0' || term_data[_y][x].getCharType() != TerminalChar::CH_CHAR)
					break;
				else
					term_data[_y][x].setLinkType( term_data[_y][link_start_x].getLinkType() );
				if( term_data[_y][x].ch == '.' )	has_dot_char = true;
			}

			//ˬdrO_ŦXWscnAOܫhWsݩ
			link_end_x = x;
			if( (link_end_x - link_start_x < 10) || (! has_dot_char) )
			{
				for(int k=link_start_x;k<link_end_x;k++)
					term_data[_y][k].setLinkType( LINK_NONE );
			}

			if( tmp_x > x )	x = tmp_x;	//[JoOקKiJLj
		}
		else
		{
			term_data[_y][x].setLinkType( LINK_NONE );
		}

	}
}
// ----------------------------------------------------------------------------
inline bool SCD_Terminal::isCharSelected(int _x, int _y)
{
	if( selectState == 2 || selectState == 3 )
	{
 		int s = start_y * col_count + start_x;
		int e = end_y * col_count + end_x;
		if( s > e )	{	int i = s;	s = e;	e = i;	}
		int n = _y * col_count + _x;
		return ( n >= s && n <= e );
	}
	else	return false;
}
// ----------------------------------------------------------------------------
void SCD_Terminal::MouseXY_to_TextXY(int m_x, int m_y, int & t_x, int & t_y)
{	//Nƹyഫ۹ry

	if( scrollwin )    	scrollwin->CalcUnscrolledPosition( m_x, m_y, &m_x, &m_y );

assert(char_width > 0);
assert(char_height > 0);

	t_x = m_x / char_width;		t_y = m_y / char_height;
	if( t_x < 0 ) t_x = 0;
	else if( t_x >= col_count ) t_x = col_count - 1;
	if( t_y < 0 ) t_y = 0;
	else if( t_y >= row_count ) t_y = row_count - 1;
}
// ----------------------------------------------------------------------------
void SCD_Terminal::repaintChar(int _x, int _y)
{
	wxDC *dc = getDC();
	if(dc == NULL) return;

	if( ! ( is_X_in_bound(_x) && is_Y_in_bound(_y) ) )	return;

	int _m, _n;	//oӤrWy
	_m = _x * char_width;
	_n = _y * char_height;

	TerminalChar & now_ch = term_data[_y][_x];

	char str[10];	//ΨxsneXr

	//pGQ, hnNmϬ
	bool isSelected = isCharSelected( _x, _y );

	if( (! getBlinkCharVisibility()) && now_ch.getBlink() )
	{ //pGܰ{{r
	    dc->SetBrush( wxBrush( now_ch.getBgColor(isSelected) , wxSOLID ) );
		dc->DrawRectangle( _m , _n , char_width , char_height);
	}
	else if( now_ch.ch == '\0' )
	{
	    dc->SetBrush( wxBrush( now_ch.getBgColor(false) , wxSOLID ) );
		dc->DrawRectangle( _m , _n , char_width , char_height);
	}
	else if( now_ch.ch == ' ' )
	{
	    dc->SetBrush( wxBrush( now_ch.getBgColor(isSelected) , wxSOLID ) );
		dc->DrawRectangle( _m , _n , char_width , char_height);
	}
	else if( now_ch.getCharType() == TerminalChar::CH_CHAR )
	{
		//eI
	    dc->SetBrush( wxBrush( now_ch.getBgColor(isSelected) , wxSOLID ) );
		dc->DrawRectangle( _m , _n , char_width , char_height);

		if( now_ch.ch < 0 )	return;	//[WoקK GTK U| crash :)
//fprintf(stderr, "char : %d -> %c\n", (int)now_ch.ch , now_ch.ch );

		//ܦr
		bool blunderline = now_ch.getUnderline();
   		if(blunderline)
   		{
      		wxFont fnt = dc->GetFont();
   	    	fnt.SetUnderlined(true);
       		dc->SetFont(fnt);
		}

		dc->SetTextForeground( now_ch.getTextColor(isSelected) );
		dc->DrawText( wxChar(now_ch.ch), _m , _n );
//		dc->DrawText( str, _m , _n );

   		if(blunderline)
   		{
      		wxFont fnt = dc->GetFont();
   	    	fnt.SetUnderlined(false);
       		dc->SetFont(fnt);
		}
	}
	else if( now_ch.getCharType() == TerminalChar::CH_WORDFIRST )
	{
		TerminalChar & next_ch = term_data[_y][_x+1];

		bool isLastWordSelected = isCharSelected( _x + 1 , _y );
		bool isSameFront =
  				( now_ch.getTextColor(isSelected) == next_ch.getTextColor(isLastWordSelected) )
  				&& ( now_ch.getUnderline() == next_ch.getUnderline() );
		bool isSameBack = ( now_ch.getBgColor(isSelected) == next_ch.getBgColor(isLastWordSelected) );


		//eI
		if( isSameBack )	//pGΦr byte ⳣۦP, N@en
		{
		    dc->SetBrush( wxBrush( now_ch.getBgColor(isSelected) , wxSOLID ) );
			dc->DrawRectangle( _m , _n , char_width + char_width , char_height);
		}
		else
		{
		    dc->SetBrush( wxBrush( now_ch.getBgColor(isSelected) , wxSOLID ) );
			dc->DrawRectangle( _m , _n , char_width , char_height);

	    	dc->SetBrush( wxBrush( next_ch.getBgColor(isLastWordSelected) , wxSOLID ) );
			dc->DrawRectangle( _m + char_width , _n , char_width , char_height);
		}

		//ܦr
		str[0] = now_ch.ch;
		str[1] = next_ch.ch;
		str[2] = '\0';
		str[3] = '\0';

//fprintf(stderr, "word : %x %x %s\n", str[0], str[1], str );

		if( isSameFront )
		{
			bool blunderline = now_ch.getUnderline();
      		if(blunderline)
      		{
	      		wxFont fnt = dc->GetFont();
    	    	fnt.SetUnderlined(true);
        		dc->SetFont(fnt);
			}

			dc->SetTextForeground( now_ch.getTextColor(isSelected) );
			dc->DrawText( wxString(str, 2), _m , _n );

      		if(blunderline)
      		{
	      		wxFont fnt = dc->GetFont();
    	    	fnt.SetUnderlined(false);
        		dc->SetFont(fnt);
			}
		}
		else	//pGΦrk䪺rC⤣@, h⦸e
		{
			bool blunderline = now_ch.getUnderline();

			//ܥb
      		if( blunderline )
      		{
	      		wxFont fnt = dc->GetFont();
    	    	fnt.SetUnderlined(true);
        		dc->SetFont(fnt);
			}
/*
static wxEncodingConverter cv;
cv.Init( wxLocale::GetSystemEncoding() , wxFONTENCODING_UNICODE );
char text[10];
strcpy(text, str);
cv.Convert( text, str );
*/
			dc->SetTextForeground( now_ch.getTextColor(isSelected) );
			dc->SetClippingRegion( _m, _n, char_width, char_height );
			dc->DrawText( wxString(str, 2), _m , _n );
			dc->DestroyClippingRegion();

			//ܥkb
			if( blunderline != next_ch.getUnderline() )
			{
       			blunderline = next_ch.getUnderline();
	      		wxFont fnt = dc->GetFont();
    	    	fnt.SetUnderlined(blunderline);
        		dc->SetFont(fnt);
			}
			
			dc->SetTextForeground( next_ch.getTextColor(isLastWordSelected) );
			dc->SetClippingRegion( _m + char_width, _n, char_width, char_height );
			dc->DrawText( wxString(str, 2), _m , _n );
			dc->DestroyClippingRegion();

      		if( blunderline )
      		{
	      		wxFont fnt = dc->GetFont();
    	    	fnt.SetUnderlined(false);
        		dc->SetFont(fnt);
			}
		}
	}
	else// if( now_ch.getCharType() == TerminalChar::CH_WORDLAST )
	{
		repaintChar(_x-1, _y);
	}
	
	
	if( now_ch.getLinkType() != LINK_NONE )
	{
		dc->SetPen( *wxCYAN_PEN );
		dc->DrawLine( _m , _n + char_height - 1 , _m + char_width , _n + char_height - 1 );
		dc->SetPen(*wxTRANSPARENT_PEN);	//T DrawRectangle() ɥ Pen e
	}
}
// ----------------------------------------------------------------------------
void SCD_Terminal::repaintLine(int _y = -1)
{
	wxDC *dc = getDC();
	if(dc == NULL)	return;
	if( _y == -1 )	_y = cur_y;

	for(int x=0;x<col_count;x++)
	{
		if( term_data[_y][x].getCharType() != TerminalChar::CH_WORDLAST )
			repaintChar(x, _y);
	}
}
// ----------------------------------------------------------------------------
inline void SCD_Terminal::repaint(bool eraseBackground)
{	getParentWindow()->Refresh( eraseBackground );	}
// ----------------------------------------------------------------------------
void SCD_Terminal::OnPaint(wxDC *dc)
{
	if( ! getVisible() )	return;

	wxRegionIterator upd( getParentWindow()->GetUpdateRegion() ); // get the update rect list
	if(!upd)	return;

	int left = 10000, right = 0, top = 10000, bottom = 0;
	while(upd)
	{
		int l = upd.GetX();
		int t = upd.GetY();
		int r = l + upd.GetW();
		int b = t + upd.GetH();

		if( l < left ) left = l;
		if( r > right ) right = r;
		if( t < top ) top = t;
		if( b > bottom ) bottom = b;

		upd++;
 	}

	BeginDrawing(dc);
	repaint( dc , left, top, right - left, bottom - top );
	EndDrawing();
}
// ----------------------------------------------------------------------------
void SCD_Terminal::OnPaint(wxPaintEvent& event)
{
	wxPaintDC dc( getParentWindow() );
	OnPaint(&dc);
}
// ----------------------------------------------------------------------------
void SCD_Terminal::repaint(wxDC *dc, int x, int y, int w, int h)
{
	if( ! getVisible() )	return;

	int left, top, right, bottom;

	left = x;  top = y;
	MouseXY_to_TextXY( left, top, left, top );
	right = left+w;		bottom = top+h;

	for(int j=top;j<=bottom;j++)
		for(int i=left;i<=right;i++)
			repaintChar(i, j);
}
// ----------------------------------------------------------------------------
void SCD_Terminal::setBlinkCharVisibility(bool _v)
{
	if( _v == blBlinkCharVisibility )	return;
	blBlinkCharVisibility = _v;

	if( ! getHasBlinkChar() )	return;	//pGثeS{{r, hX 

	wxClientDC dc( parentWindow );
	BeginDrawing(&dc);

	for(int y=0;y<row_count;y++)
		for(int x=0;x<col_count;x++)
		{
			if( term_data[y][x].getBlink() )
				repaintChar(x,y);
		}

	EndDrawing();
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_Terminal::OnMouseLeftDown(wxMouseEvent& event)
{
	switch( selectState )
	{
		case 2:
		case 3:
			CancelSelection();
		default:
	 		selectState = 1;
			MouseXY_to_TextXY( event.GetX() , event.GetY() , start_x, start_y );
			break;
	}
}
// ----------------------------------------------------------------------------
void SCD_Terminal::OnMouseMotion(wxMouseEvent& event)
{
	int _x, _y;

	MouseXY_to_TextXY( event.GetX() , event.GetY() , _x, _y );

	//pGƹSʨOr, hX, iֹBq
	if( end_y == _y && end_x == _x )	return;

	if( event.LeftIsDown() )
	{
		switch( selectState )
		{
			case 1:
   				selectState = 2;
				getParentWindow()->CaptureMouse();
   				end_x = _x;		end_y = _y;
   				break;
			case 2:
				{
					int b, e;
					if( end_y > _y )	{	b = _y;	e = end_y;	}
					else				{	b = end_y;	e = _y;	}
	
					end_x = _x;		end_y = _y;

					wxClientDC dc( getParentWindow() );
					BeginDrawing(&dc);
					for(int i=b;i<=e;i++)	repaintLine(i);
					EndDrawing();
				}


				//pGbӥBЧ֭nWLܰϤWUɽu, h۰ʱʱb
				if( scrollwin )
				{
        			int d = 0;

			     	if( event.GetY() < 0 )	d = -1;
			     	else if( event.GetY() > scrollwin->GetClientSize().GetHeight() )	d = 1;

			     	if( d != 0 )
			      	{
						int vx, vy;
			           	scrollwin->GetViewStart(&vx, &vy);
			           	vy +=d;
			           	if(vy >= 0)	scrollwin->Scroll(-1, vy);
					}
				}

				break;
		}
   	}
   	
   	if( term_data[_y][_x].getLinkType() == LINK_NONE )
   		parentWindow->SetCursor(wxNullCursor);
	else
   		parentWindow->SetCursor( wxCursor(wxCURSOR_CROSS) );
}
// ----------------------------------------------------------------------------
void SCD_Terminal::OnMouseLeftUp(wxMouseEvent& event)
{
	switch( selectState )
	{
		case 1:
			{
				if( ! OnLinkClickedFunc )	break;	//pGSwq OnLinkClickedFunc h} 

				int _x, _y;
				MouseXY_to_TextXY( event.GetX() , event.GetY() , _x, _y );
				
				//pGsrꪺ, hҰʳs
				if( term_data[_y][_x].getLinkType() != LINK_NONE )
				{
					char link[1000];
					int link_start_x;
					int i;

					//Ms}}Y
					for(i=_x;i>=0;i--)
     					if( term_data[_y][i].getLinkType() == LINK_NONE )
     						break;
     				link_start_x = i + 1;


					//ƻss}
					for(i=link_start_x;i<col_count;i++)
					{
     					if( term_data[_y][i].getLinkType() != LINK_NONE )
     						link[i-link_start_x] = term_data[_y][i].ch;
						else	break;
					}
					link[i-link_start_x] = '\0';
				
					//Ұʳs
					if( term_data[_y][_x].getLinkType() != LINK_NONE )
						OnLinkClickedFunc( link , term_data[_y][_x].getLinkType() );
				}
			}
			selectState = 0;
			break;
		case 2:
      		selectState = 3;
			getParentWindow()->ReleaseMouse();
    		break;
	}
}
// ----------------------------------------------------------------------------
void SCD_Terminal::SelectAll()
{
	start_x = 0;	start_y = 0;
	end_x = col_count - 1;	end_y = row_count - 1;
	selectState = 3;

	wxClientDC dc( getParentWindow() );
	repaint();
}
// ----------------------------------------------------------------------------
void SCD_Terminal::CancelSelection()	//
{
	switch( selectState )
	{
		case 1:
		case 2:
		case 3:
		{
			int b, e;
			if( start_y < end_y )	{	b = start_y;	e = end_y;	}
			else					{	b = end_y;	e = start_y;	}

			selectState = 0;

			wxClientDC dc( getParentWindow() );
			BeginDrawing(&dc);
			for(int i=b;i<=e;i++)	repaintLine(i);
			EndDrawing();

			break;
		}
	}
}
// ----------------------------------------------------------------------------
wxString SCD_Terminal::GetAllContent(bool withANSI)			//oҦr
{
    int sx, sy, ex, ey, ss;
    ss = selectState;

    selectState = 3;
    sx = start_x;	sy = start_y;
    ex = end_x;		ey = end_y;
    start_x = 0;	start_y = 0;
    end_x = col_count - 1;		end_y = row_count - 1;

    wxString ret = GetSelectionContent(withANSI);

    selectState = ss;
    start_x = sx;	start_y = sy;
    end_x = ex;		end_y = ey;
    
    return ret;
}    
wxString SCD_Terminal::GetSelectionContent(bool withANSI)	//oҿr
{
	if( selectState != 3 )	return wxEmptyString;
	

	//Nrƻswİ
	int s = start_y * col_count + start_x;
	int e = end_y * col_count + end_x;
	if( s > e )
	{
		int i;
		i = start_x;	start_x = end_x;	end_x = i;
		i = start_y;	start_y = end_y;	end_y = i;
	}

	//rꪺ}YMYOur䤤@b, h]ƻst~@b
	if( term_data[start_y][start_x].getCharType() == TerminalChar::CH_WORDLAST )
		start_x = start_x - 1;
	if( term_data[end_y][end_x].getCharType() == TerminalChar::CH_WORDFIRST )
		end_x = end_x + 1;
		
	int _x , _y;
	_y = start_y;
	_x = start_x;
		
	TerminalChar last_char_prop = TerminalChar::getDefaultCharProperty();
	
	wxString buf = _T(""), newlinestr = _T("");
	if( withANSI )		buf += _T("\x1b[m");
	while(1)
	{

		if( _y > end_y || (_y == end_y && _x > end_x) )	break;	//ˬd

		if( _x == 0 && _y > start_y )
		{
			buf.Append(_T("\r\n"));
			if(_y < row_count)	buf.Append( term_data[_y][_x].getANSICode() );
		}

		if( _x == col_count || term_data[_y][_x].ch == '\0' )	//pGӴF
		{	_x = 0;	_y ++;	continue;	}

		if( withANSI )
		{
			if( ! last_char_prop.withSameProperty( term_data[_y][_x] ) )
			{
				buf += term_data[_y][_x].getDiffANSICode( last_char_prop );
				last_char_prop = term_data[_y][_x];
			}
		}
				
		buf.Append( term_data[_y][_x].ch );
		_x++;

	}
	if( withANSI )		buf += _T("\x1b[m");

	return buf;
}    

#ifdef __WXGTK__
#include <iconv.h>
char* Big5ToUnicode(char *big5)
{
    static iconv_t cv;
    static bool bl_cv_inited = false;
    static char *inptr;
    static char text[1000], *outptr;
    size_t insize, outsize;
    if(!bl_cv_inited)
    {   
        cv = iconv_open("BIG5" , "Unicode");
        bl_cv_inited = true;
    }
    inptr = (char*)big5;
wxMessageBox(inptr);
    insize = 1000;
    outptr = text;
    outsize = 1000;
#ifdef __LINUX__
    iconv( cv, &inptr, &insize, &outptr, &outsize );
#else
    iconv( cv, (const char**)&inptr, &insize, &outptr, &outsize );
#endif
wxMessageBox(text);
	return strdup(text);
}
#endif

#include <wx/encconv.h>
#include "scd_gtk_textctrl.cpp"
#include <wx/textctrl.h>
void SCD_Terminal::CopySelectionToClipboard(bool withANSI)	//NrƻsŶKï
{
	if( selectState != 3 )	return;
	CopyToClipboard( GetSelectionContent(withANSI) );
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
inline bool isEnglishChar(char c)
{	return ( c >= 'A' && c <= 'Z' ) || ( c >= 'a' && c <= 'z' );	}
// ----------------------------------------------------------------------------
wxString SCD_Terminal::GetLineWrapedString(char *txt)	//N txt ۰_, ϨC@檺rƤ|WLw
{
	if( line_wraped_length <= 0 )	return txt;

	wxString output = wxEmptyString;
	char *r, *line_start;
	int now_line_len;
	line_start = r = txt;

	getXY( & now_line_len , NULL );

	bool commit = false;	//O_n
	while( *r != '\0' )
	{

		if( *r == '\x15' && r[1] == '[' )	//LX
		{
			r++;
			while(1)
			{
				r++;
				if( isalpha(*r) )	{	r++;	break;	}
				else if( *r == '\0' )	break;
			}
		}
		else
		{
			if( *r == '\n' )	//
			{	commit = true;	}
			else
			{
				if( isWord( r[0], r[1] ) && r[1] != '\0' )	//pGOr
				{
   					if( now_line_len >= line_wraped_length - 1 )	//pGӤrnb
					{	commit = true;	}
					else
					{	r+=2;	now_line_len += 2;	}
				}
				else
				{
					if( now_line_len >= line_wraped_length )	//pGӴF
					{	commit = true;	}
					else
					{	r++;	now_line_len ++;	}
				}
			}

			//commit , line_start bĤ@Ӧr, r b̫@Ӧr
			if( commit )	//pGثe׶WL, h
			{
				bool newline = false;
				if(*r=='\n')	{	r++;	newline = true;	}
				else
				{
					if( now_line_len > 0 && isEnglishChar(*(r-1)) && isEnglishChar(*r) )	//pG^rQ_r
					{
						int c = now_line_len;
						char *p = r;
						for( ; c > 0 && isEnglishChar(*p) ; c-- , p-- );
						if( c > 0 )	{	now_line_len = c;	r = p;	}

						for( ; c > 0 && *p == ' ' ; c-- , p-- );
						now_line_len = c + 1;	r = p + 1;
					}
				}

				output += wxString( line_start , r - line_start );
				if( ! newline )	output += wxString( _T("\r\n") , 2 );
				commit = false;

//    			for( ; *r == ' ' ; r ++ );	//LU@檺}Yť
				line_start = r;
				now_line_len = 0;
			}
		}
	}

	if( now_line_len > 0 )	output += wxString( line_start );
	return output;
}
// ============================================================================
#endif
